# Dieses Skript extrahiert aus einer Datei mit N Zeilen
# zufaellig m Zeilen ohne zuruecklegen
# Aufruf perl extract_random_quarts.pl m <DATEI>
# Achim Radtke 10/2004

#bsp ziehe 10000 quartette

use strict;

if(@ARGV != 2){
    print "Falsche Parameteranzahl\n";
    print "Usage: perl extract_random_quarts.pl m <DATEI>\n\n";
    print "m: Anzahl der Zeilen die zufaellig aus der Datei <DATEI> gezogen werden sollen.\n\n";
    exit;
}
my $m = $ARGV[0];
my $DATEI = $ARGV[1];


open(FH, $DATEI); # Oeffne Datei
my @DATA = <FH>;  #Lese daten
close(FH);        # Schliesse Datei
my $N = @DATA;
if($m > $N){        # Checke Vertraeglichkeit der parameter mit Dateigroesse
    print "Es gibt  nur $N Zeilen in der Datei $DATEI.\n\n";
    exit;
}
#if($m == $N){        # Behandle Sonderfall: Alle Zeilen werden gewaehlt
#    print "Mit diesen Parametern wird die komplette Datei gewaehlt.\n\n";
#    exit;
#}

print "$m\n";
for(my $i = 0; $i < $m; ++$i){
    my $zeilen_nr = random_range(0, $N);
    my $quart = splice(@DATA, $zeilen_nr, 1);
    my $label = substr($quart, 0, 2);
    $label .= substr($quart, 3, 2);
    my @LABEL = (substr($label, 0, 1) , substr($label, 1, 1) ,  substr($label, 2, 1) ,   substr($label, 3, 1));
    @LABEL = sort(@LABEL);
    $label = $LABEL[0] . $LABEL[1]. $LABEL[2] . $LABEL[3];
    print $i + 1;
    print ":$label" . ":";if(length($label)==0){print "Fehler in Zeilen Nr $zeilen_nr"};
    print $quart;
    --$N;
}
sub random_range(){
    my $low = shift;
    my $hi = shift;

    return int(rand($hi - $low + 1)) + $low;
}




