#include "./baeume.h"

// Verkettete Liste der Baumtopologien mit
// Anzahl
typedef struct topology_element{
  char ** label;
  int anzahl;
  struct topology_element * next;
} topology_element;



node * string2tree_mit_zeit(char * string);
int write_tree_topology(char ** current_tree_topology, struct node * root_ptr, int anzahl);

struct topology_element * new_topology_element(int anzahl_der_labels);
int write_into_topology_element(char ** topology, struct topology_element * t_elem, int anzahl);
struct topology_element * suche_topology(struct topology_element * t_elem, char ** t, int anzahl);
int vergleiche_topologien(struct topology_element * t1, char ** t2, int anzahl);
node * string2tree(char * string);
char * ergaenze_endknoten(char * baumstring);
int zaehle_zeichen(char * s1, char *s2);
int split_string(char *s, char ** liste, int anzahl, char * trenner);
int erzeuge_baum_aus_string(char ** liste, int anzahl, int knotenindex, node ** knotenliste);
char * substract_strings(char * s1, char * s2);
