#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <compares.h>
#include <topology.h>

int print_tree_as_text(struct node * knoten);
void main(int argc, char * argv[]){

  treelist tree;
  FILE *fp;
  int anzahl_knoten;
  char ** tree_topology;
  int i;

  if((fp = fopen(argv[1], "r")) == NULL){ // Oeffnen des Files mit Newickbaum
  printf("Fehler in main() beim Dateizugriff (lesend)!\n");
  exit(1);
  }


  tree = readNewickTreeFile(fp, 0); //Einlesen des Baumes 
  create_null_childs(tree[0].leave);

 
  // rewrite_edgelength2age(tree[0].leave);
 
  write_labels_in_tree(tree[0].leave);

 
 
  close(fp);
 
  anzahl_knoten =  count_knoten(tree[0].leave, 0);

  tree_topology = (char **) malloc (anzahl_knoten * sizeof(char *));

  write_tree_topology(tree_topology, tree[0].leave, anzahl_knoten); // Erstellen der Baumtopologie
  
  qsort(tree_topology, anzahl_knoten, sizeof(char *), comp_laenge_und_asci); // Sortieren
  printf("%s ", tree_topology[0]);
  for(i = 1; i < (anzahl_knoten - 1)/2; i++){
    printf("%s ", tree_topology[i]);
  }
  printf("\n");
  exit(1);




}
// Die folgende Funktion bekommt einen Zeiger auf einen Knoten in einem Baum und gibt den Namen des Knoten,
// sowie der direkten Kinderknoten aus (rekursiv)
int print_tree_as_text(struct node * knoten){
  //printf("%s %s %s\n", knoten->label, knoten->edges[0]->label, knoten->edges[1]->label);
  if(knoten->edges[0] != NULL){
    printf("%s: %f %s %s\n", knoten->label, knoten->edgelength,  knoten->edges[0]->label, knoten->edges[1]->label);
    print_tree_as_text(knoten -> edges[0]);
  }else{
    //printf("%s\n", knoten->label);
    return 1;
  }
  if(knoten->edges[0] != NULL){
    //printf("%s %s %s\n", knoten->label, knoten->edges[0]->label, knoten->edges[1]->label);
    print_tree_as_text(knoten->edges[1]);
  }else{
    return 1;
  }

}

