# include <stdio.h>
# include <string.h>
# include <topology.h>

void schreibe_funktionsinfo();

int main(int argc, char * argv[]){
  char * string1;
  char quelldateiinhalt[4168];
  char ** liste;
  int i;
  int anzahl;
  node * pt;
  FILE * fp_read;
  FILE * fp_write;
  char c;

  
  if(argc != 2 && argc != 3){ 
    schreibe_funktionsinfo();
    printf("test");
    exit(0);
  }
  
  if ((fp_read = fopen(argv[1], "r")) == NULL){
    printf("Fehler beim Oeffnen der Datei: %s\n", argv[1]);
    exit(0);
  }
  fgets(quelldateiinhalt, 4167, fp_read);
  *strchr(quelldateiinhalt, '\n') = '\0';
  close(fp_read);
  string1 = quelldateiinhalt;
  
  if(argc == 3){
    if((fp_write = fopen(argv[2], "w")) == NULL){
      printf("Fehler beim Oeffnen der Datei: %s\n", argv[2]);
    }
  }
 
  pt = string2tree(string1);
  
  if(pt == NULL){
    printf("Fehler.\n");
  }else{
    if(argc == 3){
      writeNewickTree(fp_write, pt);
      close(fp_write);
    }else if(argc == 2){
      printNewickTree(pt);
      printf("\n");
    }
  }
  exit(1);
}

void schreibe_funktionsinfo(){
  printf("Fehlerhafter Programmaufruf!\n\nSTRING2NEWICK(1)\n\nNAME\nstring2newick - konvertiert einen Topologiestring ins Newickformat\n\nSYNOPSIS\nstring2newick QUELLE [ZIEL]\n\nDESCRIPTION\nKonvertiert einen String der eine Baumtopologie beschreibt in das entsprechende Newickformat.\nDer String wird aus der Datei gelesen und das Ergebnis wird in die Datei ZIEL geschrieben.\nIst kein Ziel angegeben, so wird das Ergebniss auf die Standartausgabe geschrieben.\n\nAUTOR\nGeschrieben von A. Radtke\n\n\n"); 
}
