#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#define ZEILENPUFFER 40000

int main(int argc, char * argv[]){
  
  FILE * fp;
  char zeile[ZEILENPUFFER];
  int *anzahlen;
  int anzahl_der_unterbaeume;
  int * z_pt;
  char * c_pt_1;
  int i;
  int umh;
 if(argc != 4){
	printf("Usage: zaehle_subtree_matches <datei> <umh> <#subtrees>\n");
	exit (2);
}
  umh = atoi(argv[2]);
  anzahl_der_unterbaeume = atoi(argv[3]);
  if((anzahlen = (int *) malloc (anzahl_der_unterbaeume * sizeof(int))) == NULL){
	printf("Nicht genuegend Speicher fuer den ergebnissstring.\n");
	exit (3);
 }
  printf("%i:", umh);
  if((fp = fopen(argv[1], "r")) == NULL){
    printf("Fehler beim oeffnen der Datei %s.\n", argv[1]);
    exit(2);
  }

  if( fgets(zeile, ZEILENPUFFER, fp) == NULL){
    printf("Fehler beim auslesen der Datei: %s\n", argv[1]);
    exit(3);
  }
  z_pt = anzahlen;
  c_pt_1 = strchr(zeile, ',');
  ++c_pt_1;
  c_pt_1 = strchr(c_pt_1, ',');
  ++c_pt_1;
  if(c_pt_1 == NULL){
    printf("Da geht was quer.\n");
    exit(3);
  }
  
 
  for(i = 0; i < anzahl_der_unterbaeume; ++i){
    anzahlen[i] =  *c_pt_1 - '0';
    
    ++c_pt_1;
  }
  while( fgets(zeile, ZEILENPUFFER, fp) != NULL){ 
     z_pt = anzahlen;
     c_pt_1 = strchr(zeile, ',');
     ++c_pt_1;
     c_pt_1 = strchr(c_pt_1, ',');
     ++c_pt_1;
     if(c_pt_1 == NULL){
       printf("Da geht was quer.\n");
       exit(3);
     }
     for(i = 0; i < anzahl_der_unterbaeume; ++i){
       anzahlen[i] +=  *c_pt_1 - '0';
       
       ++c_pt_1;
     }
  }
  for(i = 0; i < anzahl_der_unterbaeume; ++i){
    printf("%i,", anzahlen[i]);
  }
  printf("\n");
  fclose(fp);
  exit(0);
}
