#include <errno.h>
#include <filefctns.h>
#include <string.h>

//Die folgende Funktion bekommt den Namen einer Datei und einen Zeiger auf einen Array
//Dann wird die Datei Zeilenweise in den Array gelesen. Zurueckgegeben wird die Anzahl der Zeilen.
//-1 bei Misserfolg
int readFile2Array(char * filename, char ***  zeilen, char ** filecontent){
 
  int zeilenanzahl;
  char * pt;
  int i = 0;
  int j;
  if( -1 == readFile2String(filename, filecontent) ){
    return -1;
  }
  
  zeilenanzahl = 0;
  for( i = 0; i < strlen(*filecontent); i++){
    if( (*filecontent)[i] == '\n'){
      zeilenanzahl++;
      
    }
  }
  
  *zeilen = (char **) malloc (zeilenanzahl * sizeof(char *));
  if(*zeilen == NULL){
    printf("Probleme bei der Speicherzuweisung.\n");
  }
  j = 0;
  (*zeilen)[j] = *filecontent;
  pt = *filecontent;
  while(*pt != '\0' && j < zeilenanzahl){
    if(*pt == '\n'){
      *pt = '\0';
      pt++;
      j++;
      (*zeilen)[j] = pt;
    }else{
      pt++;
    }
  }
  
  
      
  
  
  return zeilenanzahl;
}


  
  

//Die folgende Funktion bekommt den Namen einer Datei und einen
//Zeiger auf einen String. Zunaechst wird fuer den String soviel
//Speicher allokiert damit die Datei hineinpass. Dann wird der Inhalt der Datei 
//dorthin kopiert.
int readFile2String(char * filename, char ** filecontent){

  FILE * fh;
  struct stat fileinfo;
  
  if( stat(filename, &fileinfo) == -1 ){
    printf("Konnte keine Infos zu Datei %s erhalten.\n", filename);
    return -1;
  }
  
  *filecontent = (char *) malloc((fileinfo.st_size + 1 ) * sizeof(char));
  if(*filecontent == NULL){
    printf("Speicher konnte nicht allokiert werden.\n");
    return -1;
  }
  //filecontent[0] = '\0';
  if((fh = fopen(filename, "r")) == NULL){
    printf("Konnte Datei %s nicht oeffnen.\n", filename);
    return -1;
  }

  if(-1 != fread(*filecontent, sizeof(char),  fileinfo.st_size, fh)){
    fclose(fh);
    return fileinfo.st_size;
  }else{
    fclose(fh);
    
    printf("Fehler beim Auslesen der datei %s\n", filename);
    
    return -1;
  }
}
    
  
  
     
	   
