#usage perl compare_topologies.pl speciestree simulations
#-------------------------------------------------------
#this program reads in a file of simulated trees and calculates how many of these trees are
#equal to the speciestree


open speciestree, "<$ARGV[0]" or die print "cannot open speciestree file\n\n";
my @file=<speciestree>;
my $speciestree;
if (@file > 1){
	print "speciestree must fit into a single line\n";
	exit;
}
else{
	chomp $file[0];
	$speciestree=$file[0];
}

my $total_simulations=0;
my $no_topo_change=0;
open simulations, "<$ARGV[1]" or die print "cannot open simulation file\n\n";
while (<simulations>){
	chomp;
	$_=~ s/^\s+//g;
	$total_simulations++;
	if ($speciestree eq $_){
		$no_topo_change++;
	}
}
my $prob=$no_topo_change/$total_simulations;
print "$prob\t$total_simulations\t$no_topo_change\n";
