use strict;


use B::Lint;

require "/home/simone/hgt/estimate_rates/random_quartetsets/bin/TreeFormat.pm";		#EDIT

if(@ARGV == 0){
    print "Usage: perl create random quarts.pl <ANZAHL>\n";
    exit;
}
my $anzahl = $ARGV[0];

print "$anzahl\n";
for(my $j = 1; $j <= $anzahl; ++$j){
    print "$j:";
    my @labels = split("", "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqr");       	#EDIT
    my @random_nr = ();
    my @quart_labels = ();
    my @quart_sort = ();
    for(my $i = 0; $i < 4; ++$i){
    
	$random_nr[$i] = random_range(0, @labels - 1 - $i);
	$quart_labels[$i] = splice(@labels, $random_nr[$i], 1);
	@quart_sort = sort(@quart_labels);
	
    }
    print "$quart_sort[0]$quart_sort[1]$quart_sort[2]$quart_sort[3]:";
    print "$quart_labels[0]$quart_labels[1]|$quart_labels[2]$quart_labels[3]\n";
}
exit;
    

sub random_range(){
    my $low = shift;
    my $hi = shift;

    return int(rand($hi - $low + 1)) + $low;
}












