#define STRSIZE 8192

typedef struct node *nodeptr;

typedef struct node {

  char  	*label;
  int		 numofedges;
  nodeptr 	*edges;
  nodeptr	 parent;
  float		 edgelength;


} node;


typedef struct pathelement *pathlist;

typedef struct pathelement {

  nodeptr	leave;
  pathlist	next;

} pathelement;


typedef struct pathelement *treelist;


typedef struct extleave *extleavelist;

typedef struct extleave {

  char         *label;
  extleavelist  next;

} extleave;


treelist readNewickTreeFile (FILE *fp, char unrooted);

int writeNewickTree (FILE *fp, nodeptr tree);

int printNewickTree (nodeptr tree);

int writeNewickTrees (FILE *fp, treelist trees);
